package com.perforce.hws.core.test;

import org.junit.rules.TestRule;
import org.junit.runner.Description;
import org.junit.runners.model.Statement;

import java.io.File;

/**
 * Created by pallen on 16/08/2016.
 */
public class SampleServerRule extends SimpleTestServer implements TestRule {

	private String name;

	public SampleServerRule(String p4bin, String root, String version) {
		super(p4bin, root, version);
		name = "P4D(" + root + ")";
	}

	@Override
	public Statement apply(Statement statement, Description description) {
		return new ServerStatement(statement);
	}

	public class ServerStatement extends Statement {

		private final Statement statement;

		public ServerStatement(Statement statement) {
			this.statement = statement;
		}

		@Override
		public void evaluate() throws Throwable {
			clean();
			extract(new File("src/test/resources/depot.tgz"));
			restore(new File("src/test/resources/checkpoint.1"));
			upgrade();

			statement.evaluate();

			destroy();
		}
	}
}